Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Neo4j Community
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | ENUM CONSTANTS | FIELD | METHOD | DETAIL: ENUM CONSTANTS | FIELD | METHOD

## org.neo4j.graphdb
Enum Traverser.Order

    java.lang.Object
      java.lang.Enum<Traverser.Order>
          org.neo4j.graphdb.Traverser.Order

All Implemented Interfaces:
  Serializable, Comparable<Traverser.Order>

Enclosing interface:
  Traverser

    public static enum Traverser.Order

extends Enum<Traverser.Order>

Defines a traversal order as used by the traversal framework.

Nodes can be traversed either `breadth first` or `depth first`. A depth first traversal is often more likely to find one matching node before a breadth first traversal. A breadth first traversal will always find the closest matching nodes first, which means that `TraversalPosition.depth()` will return the length of the shortest path from the start node to the node at that position, which is not guaranteed for depth first traversals.

A breadth first traversal usually needs to store more state about where the traversal should go next than a depth first traversal does. Depth first traversals are thus more memory efficient.

Enum Constant Summary
`BREADTH_FIRST` Sets a breadth first traversal meaning the traverser will traverse all relationships on the current depth before going deeper.
`DEPTH_FIRST` Sets a depth first traversal meaning the traverser will go as deep as possible (increasing depth for each traversal) before traversing next relationship on same depth.

Method Summary
`static Traverser.Order` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static Traverser.Order[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### DEPTH_FIRST

    public static final Traverser.Order DEPTH_FIRST

  Sets a depth first traversal meaning the traverser will go as deep as possible (increasing depth for each traversal) before traversing next relationship on same depth.

### BREADTH_FIRST

    public static final Traverser.Order BREADTH_FIRST

  Sets a breadth first traversal meaning the traverser will traverse all relationships on the current depth before going deeper.

Method Detail

### values

    public static Traverser.Order[] values()

  Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

      for (Traverser.Order c : Traverser.Order.values())
          System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they are declared

### valueOf

    public static Traverser.Order valueOf(String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `IllegalArgumentException` - if this enum type has no constant with the specified name
    `NullPointerException` - if the argument is null

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Neo4j Community
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | ENUM CONSTANTS | FIELD | METHOD | DETAIL: ENUM CONSTANTS | FIELD | METHOD

Copyright © 2011 The Neo4j Graph Database Project. All Rights Reserved.